---
name: Request for Comments
about: Detail an idea for this project

---

<!-- Different from feature request, RFC require you explain the more detail in nebula. -->
<!-- The section `Drawbacks`, `Prior art`, `Unresolved questions` and  `Future possibilities`
     could be blank if it should be.
-->

# Summary

The overview explanation of the feature.

# Motivation

Why are we doing this? What use cases does it support? What is the expected outcome?

# Usage explanation

Explain usage of the proposal as if it was already introduced in the project. That generally means:

- Introducing new named concepts, syntax or configuration.
- Explaining the feature largely in terms of examples. If applicable, provide sample usage, output or error messages.
- Explaining the compatibility in several levels like query language, RPC structure and storage format etc.

# Design explanation

This is the technical section of the RFC. Explain the design in sufficient detail that:

- Detail how the feature will be implemented.
- From syntax, AST, planning, executing and even deep into storage etc.

# Rationale and alternatives

- Explain the ultimate purpose of the proposal. Why is this design the best in the space of possible designs?
- What other designs have been considered and what is the rationale for not choosing them?

# Drawbacks

Why should we *not* accept this? List the negative affection or shortage if exists.

# Prior art

Discuss prior art, both the good and the bad, in relation to this proposal.
A few examples of what this can include are:

- For practical proposals: Does this feature exist in other database and what experience have their community had?
- Papers: Are there any published papers or great posts that discuss this? If you have some relevant papers to refer to, this can serve as a more detailed theoretical background.

The proposal won't accepted for they are in other projects, but this will show we more productive meaning.

# Unresolved questions

- What parts of the design do you expect to resolve through the RFC process before this gets accepted?
- What parts of the design do you expect *can't* to resolve eventually in this RFC?
- What related issues do you consider out of scope for this RFC but could be addressed in the future independently of the solution that comes out of this RFC?

# Future possibilities

List the expected extensions of this proposal in future, and why better not include in current stage.

But all content in this section has no effort to determine whether we accept this proposal, in fact, it's just additional notes or even brainstorming.
